package com.loafle.overflow.module.infra.model;


import com.loafle.overflow.module.meta.model.MetaInfraType;
import com.loafle.overflow.module.probe.model.Probe;
import com.loafle.overflow.module.target.model.Target;

import javax.persistence.*;
import java.util.Date;

/**
 * Created by root on 17. 6. 22.
 */
@Entity
@Table(name = "INFRA", schema = "public", catalog = "postgres")
public class Infra {
    private long id;
    private MetaInfraType infraType;
    private long childId;
    private Date createDate;
    private Probe probe;
    private Target target;

    /*
    private long id;
    private MetaInfraType infraType;
    private long childId;
    private Date createDate;
    private Probe probeId;
    private Target targetId;
     */

    @Id
    @GeneratedValue(strategy= GenerationType.IDENTITY)
    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    @ManyToOne
    @JoinColumn(name = "TYPE_ID", nullable = false)
    public MetaInfraType getInfraType() {
        return infraType;
    }

    public void setInfraType(MetaInfraType infraType) {
        this.infraType = infraType;
    }

    @Basic
    @Column(name = "CHILD_ID", nullable = false)
    public long getChildId() {
        return childId;
    }

    public void setChildId(long childId) {
        this.childId = childId;
    }

    @Temporal(TemporalType.TIMESTAMP)
    @Column(name = "CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
    public Date getCreateDate() {
        return createDate;
    }

    public void setCreateDate(Date createDate) {
        this.createDate = createDate;
    }

    @ManyToOne
    @JoinColumn(name = "PROBE_ID", nullable = false)
    public Probe getProbe() {
        return probe;
    }

    public void setProbe(Probe probe) {
        this.probe = probe;
    }

    @ManyToOne
    @JoinColumn(name = "TARGET_ID", nullable = false)
    public Target getTarget() {
        return target;
    }

    public void setTarget(Target target) {
        this.target = target;
    }

    public static Infra CreateInfraByType(long id, Class c) {

        Infra infra = new Infra();
        infra.setChildId(id);

        MetaInfraType infraType = new MetaInfraType();
        if(c == InfraMachine.class) {
            infraType.setId(1);
        }
        else if(c == InfraHost.class) {
            infraType.setId(2);
        }
        else if(c == InfraOS.class) {
            infraType.setId(3);
        }
        else if(c == InfraOSApplication.class) {
            infraType.setId(4);
        }
        else if(c == InfraOSDaemon.class) {
            infraType.setId(5);
        }
        else if(c == InfraOSPort.class) {
            infraType.setId(6);
        }
        else if(c == InfraService.class) {
            infraType.setId(7);
        }

        infra.setInfraType(infraType);

        return infra;
    }

}
