package com.loafle.overflow.module.infra.model;


import com.loafle.overflow.module.meta.model.MetaInfraVendor;

import javax.persistence.*;
import java.util.Date;

/**
 * Created by root on 17. 6. 22.
 */
@Entity
@Table(name = "INFRA_OS", schema = "public", catalog = "postgres")
public class InfraOS {
    private long id;
    private InfraMachine machine;
    private String meta;
    private Date createDate;
    private MetaInfraVendor vendor;

    @Id
    @GeneratedValue(strategy= GenerationType.IDENTITY)
    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    @ManyToOne
    @JoinColumn(name = "MACHINE_ID", nullable = false)
    public InfraMachine getMachine() {
        return machine;
    }

    public void setMachine(InfraMachine machine) {
        this.machine = machine;
    }

    @Basic
    @Column(name = "META", nullable = true, length = 255)
    public String getMeta() {
        return meta;
    }

    public void setMeta(String meta) {
        this.meta = meta;
    }

    @Temporal(TemporalType.TIMESTAMP)
    @Column(name = "CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
    public Date getCreateDate() {
        return createDate;
    }

    public void setCreateDate(Date createDate) {
        this.createDate = createDate;
    }

    @ManyToOne
    @JoinColumn(name = "VENDOR_ID", nullable = false)
    public MetaInfraVendor getVendor() {
        return vendor;
    }

    public void setVendor(MetaInfraVendor vendor) {
        this.vendor = vendor;
    }

}
