package com.loafle.overflow.module.noauthprobe.service;

import com.loafle.overflow.module.domain.model.Domain;
import com.loafle.overflow.module.member.model.Member;
import com.loafle.overflow.module.noauthprobe.dao.NoAuthProbeDAO;
import com.loafle.overflow.module.noauthprobe.model.NoAuthProbe;
import com.loafle.overflow.module.probe.model.Probe;
import com.loafle.overflow.module.probe.service.ProbeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by snoop on 17. 6. 28.
 */
@Service("NoAuthProbeService")
public class NoAuthProbeService {

    @Autowired
    private NoAuthProbeDAO noAuthProbeDAO;

    @Autowired
    private ProbeService probeService;

    public NoAuthProbe regist(NoAuthProbe noAuthProbe) {

        return this.noAuthProbeDAO.save(noAuthProbe);
    }

    public List<NoAuthProbe> readAllByDomain(Domain domain) {

        return this.noAuthProbeDAO.findAllByDomain(domain);
    }

    public NoAuthProbe read(long id) {
        return this.noAuthProbeDAO.findOne(id);
    }

    public void registForNoAuthProbes(List<NoAuthProbe> noAuthProbes) {

        // Todo encryption key generation & probe key generation

        // Todo domain injection & member injection
//        List<Probe> resProbe = new ArrayList<>();
        Probe probe = null;
        for (NoAuthProbe noAuth : noAuthProbes) {
            probe = new Probe();
            probe.setProbeKey(noAuth.getApiKey());
            probe.setDomain(new Domain(1));
            probe.setAuthorizeMember(new Member(1));
//            resProbe.add(probe);
            this.probeService.regist(probe);
        }

    }
}
