package com.loafle.overflow.module.probe.service;

import com.loafle.overflow.module.domain.model.Domain;
import com.loafle.overflow.module.infra.model.InfraHost;
import com.loafle.overflow.module.member.model.Member;
import com.loafle.overflow.module.meta.model.MetaProbeStatus;
import com.loafle.overflow.module.probe.model.Probe;
import com.loafle.overflow.spring.AppConfigTest;
import org.junit.Assert;
import org.junit.Ignore;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import java.util.List;

/**
 * Created by snoop on 17. 6. 28.
 */
@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = {AppConfigTest.class})
public class ProbeServiceTest {

    @Autowired
    private ProbeService probeService;

    @Ignore
    @Test
    public void regist() throws Exception {

        Probe probe = new Probe();


        probe.setDescription("snoop probe");

        Domain domain = new Domain();
        domain.setId(1);

        probe.setDomain(domain);

        probe.setEncryptionKey("8c51fa9c5bcc11e7980a080027658d13");
        probe.setProbeKey("899fdd145bcc11e7b611080027658d13");

        MetaProbeStatus status = new MetaProbeStatus();
        status.setId((short)1);

        probe.setStatus(status);

        probe.setTargetCount(0);
        probe.setSensorCount(0);
        probe.setDisplayName("test probe");
        probe.setCidr("192.168.1.0/24");
//        probe.setAuthorizedDate(new Date());

        Member member = new Member();
        member.setId(1l);
        probe.setAuthorizeMember(member);

        InfraHost infraHost = new InfraHost();
        infraHost.setId(1);

        probe.setHost(infraHost);

        this.probeService.regist(probe);

        Assert.assertNotEquals(probe.getId(), 0);
    }


    @Test
    public void readAllByDomain() throws Exception {

        Domain domain = new Domain();
        domain.setId(1);

        List<Probe> probes = this.probeService.readAllByDomain(domain);

        Assert.assertEquals(probes.size(), 1);

    }

    @Ignore
    @Test
    public void readByProbeKey() throws Exception {

        regist();

        Probe probe = this.probeService.readByProbeKey("899fdd145bcc11e7b611080027658d13");

        Assert.assertNotEquals(probe, null);

    }

}